Code

utf8.c: remove print_spaces()
[git.git] / git-rebase--interactive.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2006 Johannes E. Schindelin
5 # SHORT DESCRIPTION
6 #
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
9 #
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 OPTIONS_KEEPDASHDASH=
14 OPTIONS_SPEC="\
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
17 --
18  Available options are
19 v,verbose          display a diffstat of what changed upstream
20 onto=              rebase onto given branch instead of upstream
21 p,preserve-merges  try to recreate merges instead of ignoring them
22 s,strategy=        use the given merge strategy
23 m,merge            always used (no-op)
24 i,interactive      always used (no-op)
25  Actions:
26 continue           continue rebasing process
27 abort              abort rebasing process and restore original branch
28 skip               skip current patch and continue rebasing process
29 no-verify          override pre-rebase hook from stopping the operation
30 root               rebase all reachable commmits up to the root(s)
31 "
33 . git-sh-setup
34 require_work_tree
36 DOTEST="$GIT_DIR/rebase-merge"
37 TODO="$DOTEST"/git-rebase-todo
38 DONE="$DOTEST"/done
39 MSG="$DOTEST"/message
40 SQUASH_MSG="$DOTEST"/message-squash
41 REWRITTEN="$DOTEST"/rewritten
42 DROPPED="$DOTEST"/dropped
43 PRESERVE_MERGES=
44 STRATEGY=
45 ONTO=
46 VERBOSE=
47 OK_TO_SKIP_PRE_REBASE=
48 REBASE_ROOT=
50 GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
51 mark the corrected paths with 'git add <paths>', and
52 run 'git rebase --continue'"
53 export GIT_CHERRY_PICK_HELP
55 warn () {
56         echo "$*" >&2
57 }
59 output () {
60         case "$VERBOSE" in
61         '')
62                 output=$("$@" 2>&1 )
63                 status=$?
64                 test $status != 0 && printf "%s\n" "$output"
65                 return $status
66                 ;;
67         *)
68                 "$@"
69                 ;;
70         esac
71 }
73 run_pre_rebase_hook () {
74         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
75            test -x "$GIT_DIR/hooks/pre-rebase"
76         then
77                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
78                         echo >&2 "The pre-rebase hook refused to rebase."
79                         exit 1
80                 }
81         fi
82 }
84 require_clean_work_tree () {
85         # test if working tree is dirty
86         git rev-parse --verify HEAD > /dev/null &&
87         git update-index --ignore-submodules --refresh &&
88         git diff-files --quiet --ignore-submodules &&
89         git diff-index --cached --quiet HEAD --ignore-submodules -- ||
90         die "Working tree is dirty"
91 }
93 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
95 comment_for_reflog () {
96         case "$ORIG_REFLOG_ACTION" in
97         ''|rebase*)
98                 GIT_REFLOG_ACTION="rebase -i ($1)"
99                 export GIT_REFLOG_ACTION
100                 ;;
101         esac
104 last_count=
105 mark_action_done () {
106         sed -e 1q < "$TODO" >> "$DONE"
107         sed -e 1d < "$TODO" >> "$TODO".new
108         mv -f "$TODO".new "$TODO"
109         count=$(grep -c '^[^#]' < "$DONE")
110         total=$(($count+$(grep -c '^[^#]' < "$TODO")))
111         if test "$last_count" != "$count"
112         then
113                 last_count=$count
114                 printf "Rebasing (%d/%d)\r" $count $total
115                 test -z "$VERBOSE" || echo
116         fi
119 make_patch () {
120         sha1_and_parents="$(git rev-list --parents -1 "$1")"
121         case "$sha1_and_parents" in
122         ?*' '?*' '?*)
123                 git diff --cc $sha1_and_parents
124                 ;;
125         ?*' '?*)
126                 git diff-tree -p "$1^!"
127                 ;;
128         *)
129                 echo "Root commit"
130                 ;;
131         esac > "$DOTEST"/patch
132         test -f "$DOTEST"/message ||
133                 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
134         test -f "$DOTEST"/author-script ||
135                 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
138 die_with_patch () {
139         make_patch "$1"
140         git rerere
141         die "$2"
144 die_abort () {
145         rm -rf "$DOTEST"
146         die "$1"
149 has_action () {
150         grep '^[^#]' "$1" >/dev/null
153 pick_one () {
154         no_ff=
155         case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
156         output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
157         test -d "$REWRITTEN" &&
158                 pick_one_preserving_merges "$@" && return
159         if test ! -z "$REBASE_ROOT"
160         then
161                 output git cherry-pick "$@"
162                 return
163         fi
164         parent_sha1=$(git rev-parse --verify $sha1^) ||
165                 die "Could not get the parent of $sha1"
166         current_sha1=$(git rev-parse --verify HEAD)
167         if test "$no_ff$current_sha1" = "$parent_sha1"; then
168                 output git reset --hard $sha1
169                 test "a$1" = a-n && output git reset --soft $current_sha1
170                 sha1=$(git rev-parse --short $sha1)
171                 output warn Fast-forward to $sha1
172         else
173                 output git cherry-pick "$@"
174         fi
177 pick_one_preserving_merges () {
178         fast_forward=t
179         case "$1" in
180         -n)
181                 fast_forward=f
182                 sha1=$2
183                 ;;
184         *)
185                 sha1=$1
186                 ;;
187         esac
188         sha1=$(git rev-parse $sha1)
190         if test -f "$DOTEST"/current-commit
191         then
192                 if test "$fast_forward" = t
193                 then
194                         cat "$DOTEST"/current-commit | while read current_commit
195                         do
196                                 git rev-parse HEAD > "$REWRITTEN"/$current_commit
197                         done
198                         rm "$DOTEST"/current-commit ||
199                         die "Cannot write current commit's replacement sha1"
200                 fi
201         fi
203         echo $sha1 >> "$DOTEST"/current-commit
205         # rewrite parents; if none were rewritten, we can fast-forward.
206         new_parents=
207         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
208         if test "$pend" = " "
209         then
210                 pend=" root"
211         fi
212         while [ "$pend" != "" ]
213         do
214                 p=$(expr "$pend" : ' \([^ ]*\)')
215                 pend="${pend# $p}"
217                 if test -f "$REWRITTEN"/$p
218                 then
219                         new_p=$(cat "$REWRITTEN"/$p)
221                         # If the todo reordered commits, and our parent is marked for
222                         # rewriting, but hasn't been gotten to yet, assume the user meant to
223                         # drop it on top of the current HEAD
224                         if test -z "$new_p"
225                         then
226                                 new_p=$(git rev-parse HEAD)
227                         fi
229                         test $p != $new_p && fast_forward=f
230                         case "$new_parents" in
231                         *$new_p*)
232                                 ;; # do nothing; that parent is already there
233                         *)
234                                 new_parents="$new_parents $new_p"
235                                 ;;
236                         esac
237                 else
238                         if test -f "$DROPPED"/$p
239                         then
240                                 fast_forward=f
241                                 replacement="$(cat "$DROPPED"/$p)"
242                                 test -z "$replacement" && replacement=root
243                                 pend=" $replacement$pend"
244                         else
245                                 new_parents="$new_parents $p"
246                         fi
247                 fi
248         done
249         case $fast_forward in
250         t)
251                 output warn "Fast-forward to $sha1"
252                 output git reset --hard $sha1 ||
253                         die "Cannot fast-forward to $sha1"
254                 ;;
255         f)
256                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
258                 if [ "$1" != "-n" ]
259                 then
260                         # detach HEAD to current parent
261                         output git checkout $first_parent 2> /dev/null ||
262                                 die "Cannot move HEAD to $first_parent"
263                 fi
265                 case "$new_parents" in
266                 ' '*' '*)
267                         test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
269                         # redo merge
270                         author_script=$(get_author_ident_from_commit $sha1)
271                         eval "$author_script"
272                         msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
273                         # No point in merging the first parent, that's HEAD
274                         new_parents=${new_parents# $first_parent}
275                         if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
276                                 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
277                                 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
278                                 output git merge $STRATEGY -m "$msg" \
279                                         $new_parents
280                         then
281                                 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
282                                 die_with_patch $sha1 "Error redoing merge $sha1"
283                         fi
284                         ;;
285                 *)
286                         output git cherry-pick "$@" ||
287                                 die_with_patch $sha1 "Could not pick $sha1"
288                         ;;
289                 esac
290                 ;;
291         esac
294 nth_string () {
295         case "$1" in
296         *1[0-9]|*[04-9]) echo "$1"th;;
297         *1) echo "$1"st;;
298         *2) echo "$1"nd;;
299         *3) echo "$1"rd;;
300         esac
303 make_squash_message () {
304         if test -f "$SQUASH_MSG"; then
305                 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
306                         < "$SQUASH_MSG" | sed -ne '$p')+1))
307                 echo "# This is a combination of $COUNT commits."
308                 sed -e 1d -e '2,/^./{
309                         /^$/d
310                 }' <"$SQUASH_MSG"
311         else
312                 COUNT=2
313                 echo "# This is a combination of two commits."
314                 echo "# The first commit's message is:"
315                 echo
316                 git cat-file commit HEAD | sed -e '1,/^$/d'
317         fi
318         echo
319         echo "# This is the $(nth_string $COUNT) commit message:"
320         echo
321         git cat-file commit $1 | sed -e '1,/^$/d'
324 peek_next_command () {
325         sed -n "1s/ .*$//p" < "$TODO"
328 do_next () {
329         rm -f "$DOTEST"/message "$DOTEST"/author-script \
330                 "$DOTEST"/amend || exit
331         read command sha1 rest < "$TODO"
332         case "$command" in
333         '#'*|''|noop)
334                 mark_action_done
335                 ;;
336         pick|p)
337                 comment_for_reflog pick
339                 mark_action_done
340                 pick_one $sha1 ||
341                         die_with_patch $sha1 "Could not apply $sha1... $rest"
342                 ;;
343         reword|r)
344                 comment_for_reflog reword
346                 mark_action_done
347                 pick_one $sha1 ||
348                         die_with_patch $sha1 "Could not apply $sha1... $rest"
349                 git commit --amend
350                 ;;
351         edit|e)
352                 comment_for_reflog edit
354                 mark_action_done
355                 pick_one $sha1 ||
356                         die_with_patch $sha1 "Could not apply $sha1... $rest"
357                 make_patch $sha1
358                 git rev-parse --verify HEAD > "$DOTEST"/amend
359                 warn "Stopped at $sha1... $rest"
360                 warn "You can amend the commit now, with"
361                 warn
362                 warn "  git commit --amend"
363                 warn
364                 warn "Once you are satisfied with your changes, run"
365                 warn
366                 warn "  git rebase --continue"
367                 warn
368                 exit 0
369                 ;;
370         squash|s)
371                 comment_for_reflog squash
373                 test -f "$DONE" && has_action "$DONE" ||
374                         die "Cannot 'squash' without a previous commit"
376                 mark_action_done
377                 make_squash_message $sha1 > "$MSG"
378                 failed=f
379                 author_script=$(get_author_ident_from_commit HEAD)
380                 output git reset --soft HEAD^
381                 pick_one -n $sha1 || failed=t
382                 case "$(peek_next_command)" in
383                 squash|s)
384                         USE_OUTPUT=output
385                         MSG_OPT=-F
386                         EDIT_OR_FILE="$MSG"
387                         cp "$MSG" "$SQUASH_MSG"
388                         ;;
389                 *)
390                         USE_OUTPUT=
391                         MSG_OPT=
392                         EDIT_OR_FILE=-e
393                         rm -f "$SQUASH_MSG" || exit
394                         cp "$MSG" "$GIT_DIR"/SQUASH_MSG
395                         rm -f "$GIT_DIR"/MERGE_MSG || exit
396                         ;;
397                 esac
398                 echo "$author_script" > "$DOTEST"/author-script
399                 if test $failed = f
400                 then
401                         # This is like --amend, but with a different message
402                         eval "$author_script"
403                         GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
404                         GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
405                         GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
406                         $USE_OUTPUT git commit --no-verify \
407                                 $MSG_OPT "$EDIT_OR_FILE" || failed=t
408                 fi
409                 if test $failed = t
410                 then
411                         cp "$MSG" "$GIT_DIR"/MERGE_MSG
412                         warn
413                         warn "Could not apply $sha1... $rest"
414                         die_with_patch $sha1 ""
415                 fi
416                 ;;
417         *)
418                 warn "Unknown command: $command $sha1 $rest"
419                 if git rev-parse --verify -q "$sha1" >/dev/null
420                 then
421                         die_with_patch $sha1 "Please fix this in the file $TODO."
422                 else
423                         die "Please fix this in the file $TODO."
424                 fi
425                 ;;
426         esac
427         test -s "$TODO" && return
429         comment_for_reflog finish &&
430         HEADNAME=$(cat "$DOTEST"/head-name) &&
431         OLDHEAD=$(cat "$DOTEST"/head) &&
432         SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
433         NEWHEAD=$(git rev-parse HEAD) &&
434         case $HEADNAME in
435         refs/*)
436                 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
437                 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
438                 git symbolic-ref HEAD $HEADNAME
439                 ;;
440         esac && {
441                 test ! -f "$DOTEST"/verbose ||
442                         git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
443         } &&
444         rm -rf "$DOTEST" &&
445         git gc --auto &&
446         warn "Successfully rebased and updated $HEADNAME."
448         exit
451 do_rest () {
452         while :
453         do
454                 do_next
455         done
458 # skip picking commits whose parents are unchanged
459 skip_unnecessary_picks () {
460         fd=3
461         while read command sha1 rest
462         do
463                 # fd=3 means we skip the command
464                 case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
465                 3,pick,"$ONTO"*|3,p,"$ONTO"*)
466                         # pick a commit whose parent is current $ONTO -> skip
467                         ONTO=$sha1
468                         ;;
469                 3,#*|3,,*)
470                         # copy comments
471                         ;;
472                 *)
473                         fd=1
474                         ;;
475                 esac
476                 echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
477         done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
478         mv -f "$TODO".new "$TODO" ||
479         die "Could not skip unnecessary pick commands"
482 # check if no other options are set
483 is_standalone () {
484         test $# -eq 2 -a "$2" = '--' &&
485         test -z "$ONTO" &&
486         test -z "$PRESERVE_MERGES" &&
487         test -z "$STRATEGY" &&
488         test -z "$VERBOSE"
491 get_saved_options () {
492         test -d "$REWRITTEN" && PRESERVE_MERGES=t
493         test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
494         test -f "$DOTEST"/verbose && VERBOSE=t
495         test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
498 while test $# != 0
499 do
500         case "$1" in
501         --no-verify)
502                 OK_TO_SKIP_PRE_REBASE=yes
503                 ;;
504         --verify)
505                 ;;
506         --continue)
507                 is_standalone "$@" || usage
508                 get_saved_options
509                 comment_for_reflog continue
511                 test -d "$DOTEST" || die "No interactive rebase running"
513                 # Sanity check
514                 git rev-parse --verify HEAD >/dev/null ||
515                         die "Cannot read HEAD"
516                 git update-index --ignore-submodules --refresh &&
517                         git diff-files --quiet --ignore-submodules ||
518                         die "Working tree is dirty"
520                 # do we have anything to commit?
521                 if git diff-index --cached --quiet --ignore-submodules HEAD --
522                 then
523                         : Nothing to commit -- skip this
524                 else
525                         . "$DOTEST"/author-script ||
526                                 die "Cannot find the author identity"
527                         amend=
528                         if test -f "$DOTEST"/amend
529                         then
530                                 amend=$(git rev-parse --verify HEAD)
531                                 test "$amend" = $(cat "$DOTEST"/amend) ||
532                                 die "\
533 You have uncommitted changes in your working tree. Please, commit them
534 first and then run 'git rebase --continue' again."
535                                 git reset --soft HEAD^ ||
536                                 die "Cannot rewind the HEAD"
537                         fi
538                         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
539                         git commit --no-verify -F "$DOTEST"/message -e || {
540                                 test -n "$amend" && git reset --soft $amend
541                                 die "Could not commit staged changes."
542                         }
543                 fi
545                 require_clean_work_tree
546                 do_rest
547                 ;;
548         --abort)
549                 is_standalone "$@" || usage
550                 get_saved_options
551                 comment_for_reflog abort
553                 git rerere clear
554                 test -d "$DOTEST" || die "No interactive rebase running"
556                 HEADNAME=$(cat "$DOTEST"/head-name)
557                 HEAD=$(cat "$DOTEST"/head)
558                 case $HEADNAME in
559                 refs/*)
560                         git symbolic-ref HEAD $HEADNAME
561                         ;;
562                 esac &&
563                 output git reset --hard $HEAD &&
564                 rm -rf "$DOTEST"
565                 exit
566                 ;;
567         --skip)
568                 is_standalone "$@" || usage
569                 get_saved_options
570                 comment_for_reflog skip
572                 git rerere clear
573                 test -d "$DOTEST" || die "No interactive rebase running"
575                 output git reset --hard && do_rest
576                 ;;
577         -s)
578                 case "$#,$1" in
579                 *,*=*)
580                         STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
581                 1,*)
582                         usage ;;
583                 *)
584                         STRATEGY="-s $2"
585                         shift ;;
586                 esac
587                 ;;
588         -m)
589                 # we use merge anyway
590                 ;;
591         -v)
592                 VERBOSE=t
593                 ;;
594         -p)
595                 PRESERVE_MERGES=t
596                 ;;
597         -i)
598                 # yeah, we know
599                 ;;
600         --root)
601                 REBASE_ROOT=t
602                 ;;
603         --onto)
604                 shift
605                 ONTO=$(git rev-parse --verify "$1") ||
606                         die "Does not point to a valid commit: $1"
607                 ;;
608         --)
609                 shift
610                 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
611                 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
612                 test -d "$DOTEST" &&
613                         die "Interactive rebase already started"
615                 git var GIT_COMMITTER_IDENT >/dev/null ||
616                         die "You need to set your committer info first"
618                 if test -z "$REBASE_ROOT"
619                 then
620                         UPSTREAM_ARG="$1"
621                         UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
622                         test -z "$ONTO" && ONTO=$UPSTREAM
623                         shift
624                 else
625                         UPSTREAM=
626                         UPSTREAM_ARG=--root
627                         test -z "$ONTO" &&
628                                 die "You must specify --onto when using --root"
629                 fi
630                 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
632                 comment_for_reflog start
634                 require_clean_work_tree
636                 if test ! -z "$1"
637                 then
638                         output git show-ref --verify --quiet "refs/heads/$1" ||
639                                 die "Invalid branchname: $1"
640                         output git checkout "$1" ||
641                                 die "Could not checkout $1"
642                 fi
644                 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
645                 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
647                 : > "$DOTEST"/interactive || die "Could not mark as interactive"
648                 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
649                         echo "detached HEAD" > "$DOTEST"/head-name
651                 echo $HEAD > "$DOTEST"/head
652                 case "$REBASE_ROOT" in
653                 '')
654                         rm -f "$DOTEST"/rebase-root ;;
655                 *)
656                         : >"$DOTEST"/rebase-root ;;
657                 esac
658                 echo $ONTO > "$DOTEST"/onto
659                 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
660                 test t = "$VERBOSE" && : > "$DOTEST"/verbose
661                 if test t = "$PRESERVE_MERGES"
662                 then
663                         # $REWRITTEN contains files for each commit that is
664                         # reachable by at least one merge base of $HEAD and
665                         # $UPSTREAM. They are not necessarily rewritten, but
666                         # their children might be.
667                         # This ensures that commits on merged, but otherwise
668                         # unrelated side branches are left alone. (Think "X"
669                         # in the man page's example.)
670                         if test -z "$REBASE_ROOT"
671                         then
672                                 mkdir "$REWRITTEN" &&
673                                 for c in $(git merge-base --all $HEAD $UPSTREAM)
674                                 do
675                                         echo $ONTO > "$REWRITTEN"/$c ||
676                                                 die "Could not init rewritten commits"
677                                 done
678                         else
679                                 mkdir "$REWRITTEN" &&
680                                 echo $ONTO > "$REWRITTEN"/root ||
681                                         die "Could not init rewritten commits"
682                         fi
683                         # No cherry-pick because our first pass is to determine
684                         # parents to rewrite and skipping dropped commits would
685                         # prematurely end our probe
686                         MERGES_OPTION=
687                         first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
688                 else
689                         MERGES_OPTION="--no-merges --cherry-pick"
690                 fi
692                 SHORTHEAD=$(git rev-parse --short $HEAD)
693                 SHORTONTO=$(git rev-parse --short $ONTO)
694                 if test -z "$REBASE_ROOT"
695                         # this is now equivalent to ! -z "$UPSTREAM"
696                 then
697                         SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
698                         REVISIONS=$UPSTREAM...$HEAD
699                         SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
700                 else
701                         REVISIONS=$ONTO...$HEAD
702                         SHORTREVISIONS=$SHORTHEAD
703                 fi
704                 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
705                         --abbrev=7 --reverse --left-right --topo-order \
706                         $REVISIONS | \
707                         sed -n "s/^>//p" | while read shortsha1 rest
708                 do
709                         if test t != "$PRESERVE_MERGES"
710                         then
711                                 echo "pick $shortsha1 $rest" >> "$TODO"
712                         else
713                                 sha1=$(git rev-parse $shortsha1)
714                                 if test -z "$REBASE_ROOT"
715                                 then
716                                         preserve=t
717                                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
718                                         do
719                                                 if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
720                                                 then
721                                                         preserve=f
722                                                 fi
723                                         done
724                                 else
725                                         preserve=f
726                                 fi
727                                 if test f = "$preserve"
728                                 then
729                                         touch "$REWRITTEN"/$sha1
730                                         echo "pick $shortsha1 $rest" >> "$TODO"
731                                 fi
732                         fi
733                 done
735                 # Watch for commits that been dropped by --cherry-pick
736                 if test t = "$PRESERVE_MERGES"
737                 then
738                         mkdir "$DROPPED"
739                         # Save all non-cherry-picked changes
740                         git rev-list $REVISIONS --left-right --cherry-pick | \
741                                 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
742                         # Now all commits and note which ones are missing in
743                         # not-cherry-picks and hence being dropped
744                         git rev-list $REVISIONS |
745                         while read rev
746                         do
747                                 if test -f "$REWRITTEN"/$rev -a "$(grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
748                                 then
749                                         # Use -f2 because if rev-list is telling us this commit is
750                                         # not worthwhile, we don't want to track its multiple heads,
751                                         # just the history of its first-parent for others that will
752                                         # be rebasing on top of it
753                                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
754                                         short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
755                                         grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
756                                         rm "$REWRITTEN"/$rev
757                                 fi
758                         done
759                 fi
761                 test -s "$TODO" || echo noop >> "$TODO"
762                 cat >> "$TODO" << EOF
764 # Rebase $SHORTREVISIONS onto $SHORTONTO
766 # Commands:
767 #  p, pick = use commit
768 #  r, reword = use commit, but edit the commit message
769 #  e, edit = use commit, but stop for amending
770 #  s, squash = use commit, but meld into previous commit
772 # If you remove a line here THAT COMMIT WILL BE LOST.
773 # However, if you remove everything, the rebase will be aborted.
775 EOF
777                 has_action "$TODO" ||
778                         die_abort "Nothing to do"
780                 cp "$TODO" "$TODO".backup
781                 git_editor "$TODO" ||
782                         die "Could not execute editor"
784                 has_action "$TODO" ||
785                         die_abort "Nothing to do"
787                 test -d "$REWRITTEN" || skip_unnecessary_picks
789                 git update-ref ORIG_HEAD $HEAD
790                 output git checkout $ONTO && do_rest
791                 ;;
792         esac
793         shift
794 done